=== modified file 'NEWS'
--- NEWS	2012-02-02 04:58:46 +0000
+++ NEWS	2012-02-02 07:42:24 +0000
@@ -1,8 +1,8 @@
 What's changed in loggerhead?
 =============================
 
-1.19 [????]
------------
+NEXT
+----
 
     - Add ``bzr load-test-loggerhead`` as a way to make sure loggerhead can
       handle concurrent requests, etc. Scripts can be written that spawn
@@ -52,6 +52,9 @@
     - Add a script and documentation for running under mod_wsgi.
       (Stuart Colville, Toshio Kuratomi)
 
+    - Make tz calculations consistent and use UTC in the UI everywhere we show
+      a precise timestamp. (Robert Collins, #594591)
+
 
 1.18.1 [24Mar2011]
 ------------------

=== modified file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2009-10-17 06:35:33 +0000
+++ loggerhead/controllers/directory_ui.py	2012-02-02 07:42:24 +0000
@@ -35,7 +35,7 @@
         if branch is not None:
             # If a branch is empty, bzr raises an exception when trying this
             try:
-                self.last_change = datetime.datetime.fromtimestamp(
+                self.last_change = datetime.datetime.utcfromtimestamp(
                     branch.repository.get_revision(
                         branch.last_revision()).timestamp)
             except:

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2011-02-23 03:01:15 +0000
+++ loggerhead/templates/changelog.pt	2012-02-02 07:42:24 +0000
@@ -129,8 +129,8 @@
             <td tal:condition="show_tag_col" tal:content="string:${entry/tags}"
                 class="tagcell"></td>
             <td class="date">
-              <span tal:attributes="title python:util.date_time(entry.date)"
-                    tal:content="python:util._approximatedate(entry.date)"></span>
+              <span tal:attributes="title python:util.date_time(entry.utc_date)"
+                    tal:content="python:util._approximatedate(entry.utc_date)"></span>
             </td>
             <td class="diffr"><a tal:attributes="title python:'Show diff at revision '+entry.revno;
                                                  href python:url(['/revision', entry.revno], clear=1)">

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2011-04-22 18:18:02 +0000
+++ loggerhead/templates/inventory.pt	2012-02-02 07:42:24 +0000
@@ -84,7 +84,7 @@
                                                      title string:Show revision ${file/change/revno}"
                                      tal:content="file/change/revno"></a>
                  </td>
-                 <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
+                 <td class="date" tal:content="python:util.date_time(file.change.utc_date)"></td>
                  <td class="timedate2"></td>
                  <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
                                                      title string:Show revision ${file/change/revno}">
@@ -107,7 +107,7 @@
                                                      title string:Show revision ${file/change/revno}"
                                      tal:content="file/change/revno"></a>
                  </td>
-                 <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
+                 <td class="date" tal:content="python:util.date_time(file.change.utc_date)"></td>
                  <td class="timedate2">.</td>
                  <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_file_id=file.file_id);
                                                         title string:Show revision ${file/change/revno}">
@@ -136,7 +136,7 @@
                                                   title string:Show revision ${file/change/revno}"
                                   tal:content="file/change/revno"></a>
               </td>
-              <td class="date" tal:content="python:util.date_time(file.change.date)"></td>
+              <td class="date" tal:content="python:util.date_time(file.change.utc_date)"></td>
               <td class="timedate2" tal:content="python:util.human_size(file.size)"></td>
               <td class="expcell"><a tal:attributes="href python:url(['/view', revno_url, file.absolutepath]);
                                                      title string:View ${file/filename}">

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2011-03-16 12:37:17 +0000
+++ loggerhead/templates/revisioninfo.pt	2012-02-02 07:42:24 +0000
@@ -11,7 +11,7 @@
             </li>
             <li class="timer">
                 <strong>Date:</strong>
-                <span tal:content="python:util.date_time(change.date)"></span>
+                <span tal:content="python:util.date_time(change.utc_date)"></span>
             </li>
             <li class="mfrom" tal:condition="python:change.parents[1:]">
                 <strong>mfrom:</strong>

=== modified file 'loggerhead/templates/view.pt'
--- loggerhead/templates/view.pt	2011-04-22 17:22:26 +0000
+++ loggerhead/templates/view.pt	2012-02-02 07:42:24 +0000
@@ -79,7 +79,7 @@
                   class="viewRev">
                 <a tal:content="python:'%s' % (anno.change.revno,)"
                    tal:attributes="href python:url(['/revision', anno.change.revno], clear=1);
-                                   title python:'%s by %s, on %s (%s)' % (anno.change.revno, ', '.join(util.hide_emails(anno.change.authors)), anno.change.date.strftime('%d %b %Y %H:%M'), util.date_time(anno.change.date))"></a>
+                                   title python:'%s by %s, on %s (%s)' % (anno.change.revno, ', '.join(util.hide_emails(anno.change.authors)), anno.change.utc_date.strftime('%d %b %Y %H:%M UTC'), util.date_time(anno.change.utc_date))"></a>
                 <span class="viewAuthors" tal:content="python:'by ' + ', '.join(util.hide_emails(anno.change.authors))" />
                 <br />
 

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2012-01-08 21:48:52 +0000
+++ loggerhead/util.py	2012-02-02 07:42:24 +0000
@@ -52,13 +52,12 @@
 # Display of times.
 
 # date_day -- just the day
-# date_time -- full date with time
+# date_time -- full date with time (UTC)
 #
-# displaydate -- for use in sentences
 # approximatedate -- for use in tables
 #
-# displaydate and approximatedate return an elementtree <span> Element
-# with the full date in a tooltip.
+# approximatedate return an elementtree <span> Element
+# with the full date (UTC) in a tooltip.
 
 
 def date_day(value):
@@ -67,19 +66,12 @@
 
 def date_time(value):
     if value is not None:
-        return value.strftime('%Y-%m-%d %H:%M:%S')
+        # Note: this assumes that the value is UTC in some fashion.
+        return value.strftime('%Y-%m-%d %H:%M:%S UTC')
     else:
         return 'N/A'
 
 
-def _displaydate(date):
-    delta = abs(datetime.datetime.now() - date)
-    if delta > datetime.timedelta(1, 0, 0):
-        # far in the past or future, display the date
-        return 'on ' + date_day(date)
-    return _approximatedate(date)
-
-
 def _approximatedate(date):
     delta = datetime.datetime.now() - date
     if abs(delta) > datetime.timedelta(1, 0, 0):
@@ -126,10 +118,6 @@
     return _wrap_with_date_time_title(date, _approximatedate(date))
 
 
-def displaydate(date):
-    return _wrap_with_date_time_title(date, _displaydate(date))
-
-
 class Container(object):
     """
     Convert a dict into an object with attributes.

